# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# Note: test suite fails on RHL9 but strangely not RHEL3

Name:		perl-Mail-SPF
Version:	2.8.0
Release:	1.%{__distinit}%{__distvers}
Summary:	Object-oriented implementation of Sender Policy Framework
License:	BSD
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Mail-SPF/
Source0:	http://search.cpan.org/CPAN/authors/id/J/JM/JMEHNLE/mail-spf/Mail-SPF-v%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Error)
BuildRequires:	perl(Mail::SPF::Test)
BuildRequires:	perl(Module::Build) >= 0.26
BuildRequires:	perl(NetAddr::IP) >= 4
BuildRequires:	perl(Net::DNS) >= 0.63
BuildRequires:	perl(Net::DNS::Resolver::Programmable)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(URI) >= 1.13
BuildRequires:	perl(version)
Requires:	perl(Net::DNS) >= 0.63
Requires:	perl(URI) >= 1.13
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

Requires(post):		/usr/sbin/alternatives
Requires(preun):	/usr/sbin/alternatives
Requires(postun):	/usr/sbin/alternatives, /usr/bin/readlink

%description
Mail::SPF is an object-oriented implementation of Sender Policy Framework
(SPF). See http://www.openspf.org for more information about SPF.

%prep
%setup -q -n Mail-SPF-v%{version}

# t/00.03-class-result.t fails on perl <= 5.8.0
if perl -e 'exit($^V and $^V gt 5.8.0);'; then
	mv t/00.03-class-result.t .
fi

%build
perl Build.PL installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install destdir=%{buildroot} create_packlist=0
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
chmod -R u+w %{buildroot}

# Rename spfquery and spfd for alternatives support
mv %{buildroot}%{_bindir}/spfquery		%{buildroot}%{_bindir}/spfquery.Mail::SPF
mv %{buildroot}%{_sbindir}/spfd			%{buildroot}%{_bindir}/spfd.Mail::SPF
mv %{buildroot}%{_mandir}/man1/spfquery.1	%{buildroot}%{_mandir}/man1/spfquery.Mail::SPF.1
# spfd needs to be executable
chmod +x %{buildroot}%{_bindir}/spfd.Mail::SPF
# Create %%ghost files for alternatives targets 
touch %{buildroot}%{_bindir}/spfquery 
chmod +x %{buildroot}%{_bindir}/spfquery 
touch %{buildroot}%{_bindir}/spfd 
chmod +x %{buildroot}%{_bindir}/spfd 
touch %{buildroot}%{_mandir}/man1/spfquery.1 

%check
LC_ALL=C ./Build test

%clean
rm -rf %{buildroot}

%post
/usr/sbin/alternatives \
	--install	%{_bindir}/spfquery		spf		%{_bindir}/spfquery.Mail::SPF 60 \
	--slave		%{_bindir}/spfd			spf-daemon	%{_bindir}/spfd.Mail::SPF \
	--slave		%{_mandir}/man1/spfquery.1.gz	spf-man		%{_mandir}/man1/spfquery.Mail::SPF.1.gz
exit 0

%preun
if [ $1 = 0 ]; then
	/usr/sbin/alternatives --remove spf %{_bindir}/spfquery.Mail::SPF
fi

%postun
if [ "$1" -ge "1" ]; then
	spf=`readlink /etc/alternatives/spf`
	if [ "$spf" == "%{_bindir}/spfquery.Mail::SPF" ]; then
		/usr/sbin/alternatives --set spf %{_bindir}/spfquery.Mail::SPF
	fi
fi

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE README TODO
%ghost %{_bindir}/spfd 
%ghost %{_bindir}/spfquery 
%{_bindir}/spfd.Mail::SPF
%{_bindir}/spfquery.Mail::SPF
%{perl_vendorlib}/Mail/
%ghost %{_mandir}/man1/spfquery.1.gz
%{_mandir}/man1/spfquery.Mail::SPF.1.gz
%{_mandir}/man3/Mail::SPF.3pm*
%{_mandir}/man3/Mail::SPF::Base.3pm*
%{_mandir}/man3/Mail::SPF::MacroString.3pm*
%{_mandir}/man3/Mail::SPF::Mech.3pm*
%{_mandir}/man3/Mail::SPF::Mech::A.3pm*
%{_mandir}/man3/Mail::SPF::Mech::All.3pm*
%{_mandir}/man3/Mail::SPF::Mech::Exists.3pm*
%{_mandir}/man3/Mail::SPF::Mech::IP4.3pm*
%{_mandir}/man3/Mail::SPF::Mech::IP6.3pm*
%{_mandir}/man3/Mail::SPF::Mech::Include.3pm*
%{_mandir}/man3/Mail::SPF::Mech::MX.3pm*
%{_mandir}/man3/Mail::SPF::Mech::PTR.3pm*
%{_mandir}/man3/Mail::SPF::Mod.3pm*
%{_mandir}/man3/Mail::SPF::Mod::Exp.3pm*
%{_mandir}/man3/Mail::SPF::Mod::Redirect.3pm*
%{_mandir}/man3/Mail::SPF::Record.3pm*
%{_mandir}/man3/Mail::SPF::Request.3pm*
%{_mandir}/man3/Mail::SPF::Result.3pm*
%{_mandir}/man3/Mail::SPF::SenderIPAddrMech.3pm*
%{_mandir}/man3/Mail::SPF::Server.3pm*
%{_mandir}/man3/Mail::SPF::Term.3pm*
%{_mandir}/man3/Mail::SPF::Util.3pm*
%{_mandir}/man3/Mail::SPF::v1::Record.3pm*
%{_mandir}/man3/Mail::SPF::v2::Record.3pm*

%changelog
* Mon Jan 30 2012 Paul Howarth <paul@city-fan.org> - 2.8.0-1
- Update to 2.8.0
  - Sanitize result local_explanation (as well as result object string
    representation) by replacing all non-printable or non-ascii characters with
    their hex-escaped representation, e.g. "\x00" (bugs.launchpad.net #806926)
  - Change openspf.org URLs to openspf.net because openspf.org is unreachable
    indefinitely
  - Change http://www.ietf.org/rfc/….txt URLs to http://tools.ietf.org/html/…
  - META.yml: configure_requires: Module::Build 0.2805
  - META.yml: requires: Net::DNS 0.62 (was: 0.52) (CPAN RT#28545)
  - META.yml: Revert to flat version numbers for perl and
    Net::DNS::Resolver::Programmable build requirements to avoid
    Module::Build::Compat/Makefile.PL incompatibilities (CPAN RT#53231)
  - Attempt to prevent a cascading failure in t/00.03-class-result.t that seems
    to happen under rare, unknown circumstances (CPAN RT#39099)

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 2.007-5
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 2.007-4
- Rebuild for perl 5.12.1 in Rawhide

* Fri Jun  4 2010 Paul Howarth <paul@city-fan.org> - 2.007-3
- Fix dist tag for RHEL-6 Beta

* Fri Mar  5 2010 Paul Howarth <paul@city-fan.org> - 2.007-2
- Dist tag for Rawhide no longer needs special-casing

* Mon Nov  2 2009 Paul Howarth <paul@city-fan.org> - 2.007-1
- Update to 2.007 (see CHANGES for details)

* Fri Sep 18 2009 Paul Howarth <paul@city-fan.org> - 2.006-2
- Define RPM macros in global scope
- %%ghost alternatives targets 
- %%postun requires /usr/bin/readlink

* Thu Oct 16 2008 Paul Howarth <paul@city-fan.org> - 2.006-1
- Import from Fedora
- Update to 2.006
- Include spfquery and spfd with alternatives support
- Buildreq Module::Build >= 0.26
- Buildreq and Req Net::DNS >= 0.63 (CPAN RT#28545)

* Thu Mar 06 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 2.005-2
- Rebuild for new perl

* Mon Jul 09 2007 Steven Pritchard <steve@kspei.com> 2.005-1
- Specfile autogenerated by cpanspec 1.71.
- Add the "v" before version numbers to handle broken upstream packaging.
- Remove redundant perl build dependency.
- Drop bogus version number from Net::DNS::Resolver::Programmable dependency.
- Drop redundant explicit dependencies.
- BR Test::More and Test::Pod.
- Include the spfd and spfquery scripts as %%doc
